/*
 * epspProtocol.c version 2.1 part of the Epspd88 2.1 package
 *
 * Copyright 2009 Fred Jan Kraan
 *
 * This version delivered in 2009 by Fred Jan Kraan (fjkraan@xs4all.nl)
 *
 * epspCode is placed under the GNU General Public License in June 2009.
 *
 *  This file is part of Epspd88 2.1.
 *
 *  Epspd88 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Epspd88 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Epspd88; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 * epspProtocol - epsp protocol functions for epspd.c.
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#include "epspv3.h"
#include "fdc.h"
#include "epspHeaders.h"

extern int epsp_port;
extern int debug;

extern struct driveParameters driveParam;
extern struct behaviour protocolHandler;

void sendNAK() {
        char dp=NAK;
        epspWrite(epsp_port, &dp, 1);
        if (debug > 2)
                printf("  sendNAK; Sent NAK\n");
}

int waitForACK() {
        char dp;
        epspRead(epsp_port, &dp, 1);
        if (dp == ACK) {
                if (debug > 2) printf("  waitForACK; good: ACK received\n");
                return(1);
        } else if (dp == NAK) {
                if (debug > 2) printf("  waitForACK; warn: > > > > > > NAK received < < < < < <\n");
        } else {
                printf("  waitForACK; warning: no ACK but %02X received\n", dp & 0xFF);
        }
        return(0);
}

void sendACK() {
        char dp=ACK;
        epspWrite(epsp_port, &dp, 1);
        if (debug > 2)
                printf("  sendACK; Sent ACK\n");
}

int waitForEOT() {
        char dp;
        epspRead(epsp_port, &dp, 1);
        if (dp == EOT) {
                if (debug > 2) printf("  waitForEOT; good: EOT received\n");
                return(1);
        }
        printf("  waitForEOT; warning: no EOT but %02X received\n", dp & 0xFF);
        return(0);
}

void sendEOT() {
        char dp = EOT;
        epspWrite(epsp_port, &dp, 1);
        if (debug > 2)
                printf("  sendEOT; Sent EOT\n");
}

void nullFunction() {
}

int nullFunctionOk() {
	return(1);
}

